package com.ludoko.ld48;
import flixel.FlxG;
import flixel.FlxSprite;

/**
 * ...
 * @author Michael Lee
 */
class CircleFade extends FlxSprite
{
	
	public var tutorialMode:Bool = false;
	
	public var speed:Float = 1;
	public var fadeSpeed:Float = 1;
	
	public function new(X:Float, Y:Float, Size:Int, Color:Int, InitialScale = 0, Speed:Float = 1, FadeSpeed:Float = 1) 
	{
		var hs:Float = Size * 0.5;
		super(X - hs, Y - hs);
		
		speed = Speed;
		fadeSpeed = FadeSpeed;
		
		if (Size == 64)
		{
			loadGraphic("assets/images/game/circle_64.png");
		}
		else if (Size == 96)
		{
			loadGraphic("assets/images/game/circle_96.png");
		}
		antialiasing = false;
		color = Color;
		alpha = _initialAlpha = 0.25;
		
		setScale(InitialScale, true);
	}
	
	public function setScale(Scale:Float, Force:Bool = false):Void
	{
		if (_scale != Scale)
		{
			scale.x = scale.y = Scale;
		}
		_scale = Scale;
	}
	
	override public function update():Void 
	{
		var newScale:Float = _scale;
		newScale += FlxG.elapsed * speed;
		setScale(newScale);
		
		alpha -= FlxG.elapsed * _initialAlpha * fadeSpeed;
		if (alpha <= 0)
		{
			kill();
		}
		
		super.update();
	}
	
	override public function kill():Void 
	{
		if (!tutorialMode)
		{
			G.playstate.fades.remove(this, true);
		}
		else
		{
			G.tutorialstate.fades.remove(this, true);
		}
		super.kill();
	}
	
	private var _scale:Float = 1;
	private var _initialAlpha:Float;
	
}