package com.ludoko.ld48;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.text.FlxText;

class MenuState extends FlxState
{
	
	override public function create():Void
	{
		// Set a background color
		FlxG.camera.bgColor = 0xfffdfdfd;
		
		// Show the mouse (in case it hasn't been disabled)
		#if !FLX_NO_MOUSE
		FlxG.mouse.hide();
		FlxG.mouse.useSystemCursor = true;
		#end
		
		super.create();
		
		var bg:FlxSprite = new FlxSprite(0, 0, "assets/images/game/bg.png");
		_grid = new ScrollGrid();
		var title:FlxSprite = new FlxSprite(Math.ffloor((FlxG.width - 239) * 0.5), 64, "assets/images/game/title.png");
		
		var credit:FlxText = new FlxText(8, 134, FlxG.width - 16, "GAME BY MICHAEL LEE");
		credit.setFormat(Assets.FNT_GUBBLABLO, 20, 0xb7b8bd, "center");
		
		
		_text = new FlxText(0, FlxG.height - 48, FlxG.width, "Z TO PLAY\nX FOR INSTRUCTIONS");
		_text.setFormat(Assets.FNT_GUBBLABLO, 20, 0xfdfdfd, "center");
		
		
		add(bg);
		add(_grid);
		add(title);
		add(credit);
		add(_text);
	}
	
	
	override public function destroy():Void
	{
		super.destroy();
	}

	
	override public function update():Void
	{
		if (FlxG.keyboard.justPressed("Z"))
		{
			FlxG.switchState(new PlayState());
		}
		if (FlxG.keyboard.justPressed("X"))
		{
			FlxG.switchState(new TutorialState());
		}
		
		super.update();
	}
	
	private var _grid:ScrollGrid;
	private var _text:FlxText;
	
}