package com.ludoko.ld48;

import flash.display.BlendMode;
import flixel.FlxG;
import flixel.FlxSprite;
import flixel.util.FlxRandom;

/**
 * ...
 * @author ...
 */
class TimerBar extends FlxSprite
{

	public function new() 
	{
		super(0, 0);
		makeGraphic(FlxG.width, FlxG.height, 0xffe9662c);
		//blend = BlendMode.OVERLAY;
		alpha = 0.15;
		
		resetTimer(2);
	}
	
	public function resetTimer(Direction:Int = -1):Void
	{
		if (Direction == -1)
		{
			Direction = FlxRandom.intRanged(0, 3);
		}
		
		if (Direction == 0)
		{
			x = -FlxG.width;
			y = 0;
		}
		else if (Direction == 1)
		{
			x = FlxG.width;
			y = 0;
		}
		else if (Direction == 2)
		{
			x = 0;
			y = -FlxG.height;
		}
		else 
		{
			x = 0;
			y = FlxG.height;
		}
		
		_fillDirection = Direction;
	}
	
	override public function update():Void 
	{
		var t:Float = 1 - (G.timer / 10);
		if (_fillDirection == 0)
		{
			x = -FlxG.width + (t * FlxG.width);
		}
		else if (_fillDirection == 1)
		{
			x = FlxG.width - (t * FlxG.width);
		}
		else if (_fillDirection == 2)
		{
			y = -FlxG.height + (t * FlxG.height);
		}
		else
		{
			y = FlxG.height - (t * FlxG.height);
		}
		
		super.update();
	}
	
	private var _fillDirection:Int = 0;
	
}