package com.ludoko.ld48;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.group.FlxGroup;
import flixel.text.FlxText;

/**
 * ...
 * @author ...
 */
class TutorialState extends FlxState
{

	public var fades:FlxGroup;
	
	override public function create():Void
	{
		G.tutorialstate = this;
		
		// Set a background color
		FlxG.camera.bgColor = 0xfffdfdfd;
		
		// Show the mouse (in case it hasn't been disabled)
		#if !FLX_NO_MOUSE
		FlxG.mouse.hide();
		FlxG.mouse.useSystemCursor = true;
		#end
		
		super.create();
		
		
		var bg:FlxSprite = new FlxSprite(0, 0, "assets/images/game/bg.png");
		_grid = new ScrollGrid();
		
		add(bg);
		add(_grid);
		
		fades = new FlxGroup();
		
		var c:TimeCircle;
		
		c = new TimeCircle(0, 84, 155, 64);
		c.tutorialMode = true;
		c.gameState = this;
		add(c);
		c = new TimeCircle(1, FlxG.width * 0.5, 155, 64);
		c.tutorialMode = true;
		c.gameState = this;
		add(c);
		c = new TimeCircle(2, FlxG.width - 84, 155, 64);
		c.tutorialMode = true;
		c.gameState = this;
		add(c);
		
		add(fades);
		
		var t:FlxText;
		
		t = new FlxText(8, 12, FlxG.width - 16, "DODGE BULLETS TO SURVIVE\n\nMOVE WITH ARROW KEYS\nJUMP WITH Z\n\nUSE TIME CIRCLES\nTO YOUR ADVANTAGE!");
		add(t);
		t.setFormat(Assets.FNT_GUBBLABLO, 20, 0xb7b8bd, "center");
		
		t = new FlxText(44, 192, 80, "SLOW BULLETS/TIME");
		add(t);
		t.setFormat(Assets.FNT_GUBBLABLO, 10, 0xb7b8bd, "center");
		
		t = new FlxText(FlxG.width * 0.5 - 40, 192, 80, "FAST BULLETS/TIME");
		add(t);
		t.setFormat(Assets.FNT_GUBBLABLO, 10, 0xb7b8bd, "center");
		
		t = new FlxText(FlxG.width - 124, 192, 80, "REVERSE BULLETS/TIME");
		add(t);
		t.setFormat(Assets.FNT_GUBBLABLO, 10, 0xb7b8bd, "center");
		
		t = new FlxText(0, FlxG.height - 24, FlxG.width, "Z TO PLAY");
		add(t);
		t.setFormat(Assets.FNT_GUBBLABLO, 20, 0xfdfdfd, "center");
	}
	
	
	override public function destroy():Void
	{
		super.destroy();
	}
	
	
	public function addCircleFade(X:Float, Y:Float, Size:Int, Color:Int, InitialScale = 0, Speed:Float = 1, FadeSpeed:Float = 1):CircleFade
	{
		var f:CircleFade = new CircleFade(X, Y, Size, Color, InitialScale, Speed, FadeSpeed);
		f.tutorialMode = true;
		fades.add(f);
		return f;
	}

	
	override public function update():Void
	{
		if (FlxG.keyboard.justPressed("Z"))
		{
			FlxG.switchState(new PlayState());
		}
		
		super.update();
	}
	
	private var _state:Int = 0;
	private var _grid:ScrollGrid;
	
}